
// save mzf file to Sharp MZ800 - test project 15.7.2017

/*


http://www.sharpmz.org/mz-800/download/MZ800_Technical_reference_manual.pdf on page 43 is T5 connector to CMT

How to connect it:
Arduino D12 - Sharp T5-pin8 READ
Arduino GND - Sharp T5-pin5 SENCE
Arduino GND - Sharp T5-pin9 GND


*/

#include <SoftwareSerial.h>

const int READ = 12;

SoftwareSerial mySerial(0, 1); 

// the setup function runs once when you press reset or power the board
void setup() {
  // initialize 
  pinMode(READ, OUTPUT);
  digitalWrite(READ, HIGH);
  mySerial.begin(115200);
}

// the loop function runs over and over again forever
long time1;
long time2;

void ShortImpuls() {
  digitalWrite(READ, LOW);   // 
  delayMicroseconds(240);                         // wait for 240us
  digitalWrite(READ, HIGH);
  delayMicroseconds(278-8);                       // wait for 278us
}

void LongImpuls() {
  digitalWrite(READ, LOW);   // 
  delayMicroseconds(470);                         // wait for 470us
  digitalWrite(READ, HIGH);
  delayMicroseconds(494-8);                       // wait for 494us
}

void Ten_Seconds_ShortImpuls() {
  for (int i=0; i < 22000 ; i++){  // 22000 pulsu Short
    ShortImpuls();
    }
}

void Five_Seconds_ShortImpuls() {
  for (int i=0; i < 11000 ; i++){  // 11000 pulsu Short
    ShortImpuls();
    }
}

void TapeMark_header() {
  for (int i=0; i < 40 ; i++){  // 40 pulsu Long
    LongImpuls();
    }
  for (int i=0; i < 40 ; i++){  // 40 pulsu Short
    ShortImpuls();
    }
}

void TapeMark_Data() {
  for (int i=0; i < 20 ; i++){  // 20 pulsu Long
    LongImpuls();
    }
  for (int i=0; i < 20 ; i++){  // 20 pulsu Short
    ShortImpuls();
    }
}

void Short256() {
  for (int i=0; i < 256 ; i++){  
    ShortImpuls();
    }
}


void SendByte(byte co){
    LongImpuls();
    if ( (co & 0x80 ) == 0 ) ShortImpuls(); else LongImpuls();
    if ( (co & 0x40 ) == 0 ) ShortImpuls(); else LongImpuls();
    if ( (co & 0x20 ) == 0 ) ShortImpuls(); else LongImpuls();
    if ( (co & 0x10 ) == 0 ) ShortImpuls(); else LongImpuls();
    if ( (co & 0x08 ) == 0 ) ShortImpuls(); else LongImpuls();
    if ( (co & 0x04 ) == 0 ) ShortImpuls(); else LongImpuls();
    if ( (co & 0x02 ) == 0 ) ShortImpuls(); else LongImpuls();
    if ( (co & 0x01 ) == 0 ) ShortImpuls(); else LongImpuls();
}

byte header[128];
byte header_crc[2];
byte data[128];
byte data_crc[2];
 
void SendCrcHeader(){
   SendByte(header_crc[1]); // high byte first
   SendByte(header_crc[0]); // low byte next
};

void SendCrcData(){
   SendByte(data_crc[1]);
   SendByte(data_crc[0]);
};

void SendHeader(){
   for (int i=0; i < 128 ; i++){  
    SendByte(header[i]);
   }
};

void SendData(int kolik){
   for (int i=0; i< kolik ; i++){  
    SendByte(data[i]);
   }
   }
;

void Crc_calculation_header(){
  int crc1;
  byte co;
  
  crc1=0;
  for (int i=0; i < 128 ; i++){  
    co=header[i];
    if ( (co & 0x80 ) != 0 ) crc1++;
    if ( (co & 0x40 ) != 0 ) crc1++;
    if ( (co & 0x20 ) != 0 ) crc1++;
    if ( (co & 0x10 ) != 0 ) crc1++;
    if ( (co & 0x08 ) != 0 ) crc1++;
    if ( (co & 0x04 ) != 0 ) crc1++;
    if ( (co & 0x02 ) != 0 ) crc1++;
    if ( (co & 0x01 ) != 0 ) crc1++;
  };
  header_crc[0]=crc1 % 256;
  header_crc[1]=crc1 / 256;
  };

void Crc_calculation_data(int kolik){
  int crc1;
  byte co;
  
  crc1=0;
  for (int i=0; i < kolik ; i++){  
    co=data[i];
    if ( (co & 0x80 ) != 0 ) crc1++;
    if ( (co & 0x40 ) != 0 ) crc1++;
    if ( (co & 0x20 ) != 0 ) crc1++;
    if ( (co & 0x10 ) != 0 ) crc1++;
    if ( (co & 0x08 ) != 0 ) crc1++;
    if ( (co & 0x04 ) != 0 ) crc1++;
    if ( (co & 0x02 ) != 0 ) crc1++;
    if ( (co & 0x01 ) != 0 ) crc1++;
  };
  data_crc[0]=crc1 % 256;
  data_crc[1]=crc1 / 256;
  }

void loop() {
  mySerial.println("begin");

int i;
 for (int i=0; i < 128 ; i++){  
    header[i]=0;
 };
 for (int i=1; i < 18 ; i++){  
    header[i]=13;
 };
 header[0]=1; // obj
 header[1]='A';
 header[2]=13;    // CR
int kolik_bajtu;
 kolik_bajtu=4;
 header[18]=kolik_bajtu % 256; // size
 header[19]=kolik_bajtu / 256;
 header[20]=0;
 header[21]=0x12; // load addr
 header[22]=0;
 header[23]=0x12; // exec addr
 Crc_calculation_header();


  for (int i=0; i < 128 ; i++){  
    data[i]=0;
 };
 data[0]=0xcd; // call getl
 data[1]=0x03; // 
 data[2]=0x00; // 
 data[3]=0xc9; // ret
  Crc_calculation_data(kolik_bajtu);

  mySerial.println("header");
  /*
  mySerial.println(header[0]);
  mySerial.println(header[1]);
  mySerial.println(header[2]);
  mySerial.println(header[21]);
  mySerial.println("");
  mySerial.println(header_crc[0]);
  mySerial.println(header_crc[1]);
*/
  time1=micros();

  Ten_Seconds_ShortImpuls();
  TapeMark_header();
  LongImpuls();
  SendHeader();
  SendCrcHeader();
  LongImpuls();
  Short256();
  SendHeader();
  SendCrcHeader();
  LongImpuls();
  mySerial.println("data");

  Five_Seconds_ShortImpuls();
  TapeMark_Data();
  LongImpuls();
  SendData(kolik_bajtu);
  SendCrcData();
  LongImpuls();
  Short256();
  SendData(kolik_bajtu);
  SendCrcData();
  LongImpuls();

  time2=micros();
  mySerial.print(time2-time1);
  mySerial.println();
  mySerial.println();
  
 delay(100);
}

